Index: trunk/source/persistency/ascii/src/G4tgrSolidBoolean.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrSolidBoolean.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrSolidBoolean.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrSolidBoolean.cc,v 1.4 2008/12/18 13:00:12 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrVolume.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrVolume.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrVolume.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4tgrVolume.cc,v 1.7 2008/12/18 13:00:16 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4tgrVolume.cc,v 1.10 2009/11/23 11:36:29 arce Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -109,4 +109,18 @@
 
 //-------------------------------------------------------------------------
+G4tgrVolume::G4tgrVolume( const G4tgrVolume& vol )
+{
+  theName = vol.GetName();   
+  theType = vol.GetType();
+  theMaterialName = vol.GetMaterialName();   
+  theSolid = const_cast<G4tgrSolid*>(vol.GetSolid());
+  thePlacements  = vol.GetPlacements();
+  theVisibility   = vol.GetVisibility();
+  theRGBColour   = vol.GetRGBColour();
+  theCheckOverlaps = vol.GetCheckOverlaps();
+}
+
+
+//-------------------------------------------------------------------------
 G4tgrVolume* G4tgrVolume::GetVolume( G4int ii ) const
 {
Index: trunk/source/persistency/ascii/src/G4tgrVolumeAssembly.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrVolumeAssembly.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrVolumeAssembly.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrVolumeAssembly.cc,v 1.6 2008/12/18 13:00:18 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrVolumeDivision.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrVolumeDivision.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrVolumeDivision.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrVolumeDivision.cc,v 1.6 2008/12/18 13:00:20 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/ascii/src/G4tgrVolumeMgr.cc
===================================================================
--- trunk/source/persistency/ascii/src/G4tgrVolumeMgr.cc	(revision 1227)
+++ trunk/source/persistency/ascii/src/G4tgrVolumeMgr.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4tgrVolumeMgr.cc,v 1.7 2008/12/18 13:00:22 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/gdml/History
===================================================================
--- trunk/source/persistency/gdml/History	(revision 1227)
+++ trunk/source/persistency/gdml/History	(revision 1228)
@@ -1,3 +1,3 @@
-$Id: History,v 1.101 2009/02/26 10:13:49 gcosmo Exp $
+$Id: History,v 1.116 2009/12/04 13:59:05 gcosmo Exp $
 -------------------------------------------------------------------
 
@@ -17,4 +17,70 @@
      * Reverse chronological order (last date on top), please *
      ----------------------------------------------------------
+
+04 Dec 2009 Gabriele Cosmo (gdml-V09-02-18)
+- Updated list of optical properties in G4GDMLReadSolid according to
+  last changes to G4OpticalSurface and G4SurfaceProperty.
+
+14 Oct 2009 Gabriele Cosmo (gdml-V09-02-17)
+- Added support for GDML 'expression' tag, implementing generic expressions
+  stored as literal constants.
+- Corrected handling of 'quantity' tag; added missing caching of evaluation. 
+
+24 Sep 2009 Gabriele Cosmo (gdml-V09-02-16)
+- Added support for the GDML 'assembly' tag, implementing assemblies of
+  simple placements through G4AssemblyVolume.
+
+12 May 2009 Gabriele Cosmo (gdml-V09-02-15)
+- Restricted usage of loops only for placement of volumes. Now correctly
+  handling most common use-case of multiple copies of the same volume/solid
+  through loop statement. Addressing problem report #1063.
+
+11 May 2009 Gabriele Cosmo (gdml-V09-02-14)
+- Allow for name stripping of volumes which are included in loops; do not
+  store appended internal counter reference.
+
+27 April 2009 Gabriele Cosmo (gdml-V09-02-13)
+- Get rid of unused parameter in G4GDMLWriteMaterials::PropertyVectorWrite().
+
+24 April 2009 Gabriele Cosmo (gdml-V09-02-12)
+- Some code cleanup: rationalised inclusion of headers, replacing them
+  with forward declarations where possible.
+
+24 April 2009 Gabriele Cosmo (gdml-V09-02-11)
+- Allow for reading/writing of constant material properties.
+- Implemented ability to write surface properties associated to volumes
+  and material properties.
+
+17 April 2009 Gabriele Cosmo (gdml-V09-02-10)
+- Defined missing copy constructor and operator=() to G4GDMLMatrix
+  internal class, to avoid cases of memory corruption when handling matrices.
+
+15 April 2009 Gabriele Cosmo (gdml-V09-02-09)
+- Completed virtual layer for allowing customisation of the writer for
+  user-extended schemas.
+
+09 April 2009 Gabriele Cosmo (gdml-V09-02-08)
+- Correction in G4GDMLWriteSolids::BooleanWrite() in order to handle
+  cases of nested displaced solids given to both operands in a Boolean
+  operation (ATLAS use case).
+- Renamed flag for maximum number of transformations applied to a solid
+  and moved to G4GDMLWriteSolids base class.
+- First virtual layer for custom writer classes G4GDMLWriteSolids and
+  G4GDMLWriteStructure.
+
+03 April 2009 Tatiana Nikitina (gdml-V09-02-07)
+- Correction in materials and solids tags for allowing parsing of
+  definitions within the tag scope; possibility foreseen by the schema.
+
+24 March 2009 Gabriele Cosmo (gdml-V09-02-06)
+- Added empty default constructor and virtual destructor to classes in the
+  inheritance chain.
+
+02 March 2009 Gabriele Cosmo (gdml-V09-02-05)
+- Fixed association of entities in nested loops for solids and materials.
+  Definitions of materials are not supposed to be included in loops being
+  therefore repeated...
+- Strip off white spaces from names G4GDMLWrite::GenerateName(), to avoid
+  parsing problems in imported files.
 
 26 February 2009 Tatiana Nikitina (gdml-V09-02-04)
Index: trunk/source/persistency/gdml/include/G4GDMLEvaluator.hh
===================================================================
--- trunk/source/persistency/gdml/include/G4GDMLEvaluator.hh	(revision 1227)
+++ trunk/source/persistency/gdml/include/G4GDMLEvaluator.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLEvaluator.hh,v 1.16 2008/07/16 15:46:33 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLEvaluator.hh,v 1.17 2009/04/24 15:34:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -45,5 +45,5 @@
 #include <vector>
 
-#include "globals.hh"
+#include "G4Types.hh"
 
 class G4GDMLEvaluator
Index: trunk/source/persistency/gdml/include/G4GDMLParameterisation.hh
===================================================================
--- trunk/source/persistency/gdml/include/G4GDMLParameterisation.hh	(revision 1227)
+++ trunk/source/persistency/gdml/include/G4GDMLParameterisation.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4GDMLParameterisation.hh,v 1.10 2008/07/16 15:46:33 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/gdml/include/G4GDMLParser.hh
===================================================================
--- trunk/source/persistency/gdml/include/G4GDMLParser.hh	(revision 1227)
+++ trunk/source/persistency/gdml/include/G4GDMLParser.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLParser.hh,v 1.57 2009/01/22 11:02:07 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLParser.hh,v 1.58 2009/04/15 13:29:30 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -54,4 +54,5 @@
    G4GDMLParser();
    G4GDMLParser(G4GDMLReadStructure*);
+   G4GDMLParser(G4GDMLReadStructure*, G4GDMLWriteStructure*);
   ~G4GDMLParser();
      //
@@ -113,5 +114,5 @@
    G4GDMLReadStructure* reader;
    G4GDMLWriteStructure* writer;
-   G4bool ucode;
+   G4bool urcode, uwcode;
 
 };
Index: trunk/source/persistency/gdml/include/G4GDMLParser.icc
===================================================================
--- trunk/source/persistency/gdml/include/G4GDMLParser.icc	(revision 1227)
+++ trunk/source/persistency/gdml/include/G4GDMLParser.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4GDMLParser.icc,v 1.8 2009/01/22 11:02:07 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/persistency/gdml/include/G4GDMLRead.hh
===================================================================
--- trunk/source/persistency/gdml/include/G4GDMLRead.hh	(revision 1227)
+++ trunk/source/persistency/gdml/include/G4GDMLRead.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLRead.hh,v 1.27 2009/01/22 11:02:07 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLRead.hh,v 1.31 2009/05/12 15:46:43 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4GDMLRead
@@ -47,11 +47,10 @@
 #include <xercesc/dom/DOM.hpp>
 
+#include "G4Types.hh"
+
 #include "G4GDMLEvaluator.hh"
 
-#include "G4LogicalVolume.hh"
-#include "G4VisAttributes.hh"
-#include "G4PVPlacement.hh"
-
-#include <sstream>
+class G4LogicalVolume;
+class G4VPhysicalVolume;
 
 class G4GDMLErrorHandler : public xercesc::ErrorHandler
@@ -149,5 +148,5 @@
  private:
 
-   G4int inLoop;
+   G4int inLoop, loopCount;
 
 };
Index: trunk/source/persistency/gdml/include/G4GDMLReadDefine.hh
===================================================================
--- trunk/source/persistency/gdml/include/G4GDMLReadDefine.hh	(revision 1227)
+++ trunk/source/persistency/gdml/include/G4GDMLReadDefine.hh	(revision 1228)
@@ -41,4 +41,6 @@
 
 #include "G4ThreeVector.hh"
+#include "G4RotationMatrix.hh"
+
 #include "G4GDMLRead.hh"
 
@@ -50,5 +52,7 @@
    G4GDMLMatrix();
    G4GDMLMatrix(size_t rows0,size_t cols0);
-   ~G4GDMLMatrix();
+   G4GDMLMatrix(const G4GDMLMatrix& rhs);
+   G4GDMLMatrix& operator=(const G4GDMLMatrix& rhs); 
+  ~G4GDMLMatrix();
 
    void Set(size_t r,size_t c,G4double a);
@@ -80,4 +84,7 @@
  protected:
 
+   G4GDMLReadDefine();
+   virtual ~G4GDMLReadDefine();
+
    G4RotationMatrix GetRotationMatrix(const G4ThreeVector&);
    void VectorRead(const xercesc::DOMElement* const,G4ThreeVector&);
@@ -90,5 +97,6 @@
    void ScaleRead(const xercesc::DOMElement* const);
    void VariableRead(const xercesc::DOMElement* const); 
-   void QuantityRead(const xercesc::DOMElement* const); 
+   void QuantityRead(const xercesc::DOMElement* const);
+   void ExpressionRead(const xercesc::DOMElement* const);
 
  protected:
Index: trunk/source/persistency/gdml/include/G4GDMLReadMaterials.hh
===================================================================
--- trunk/source/persistency/gdml/include/G4GDMLReadMaterials.hh	(revision 1227)
+++ trunk/source/persistency/gdml/include/G4GDMLReadMaterials.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLReadMaterials.hh,v 1.9 2008/11/20 15:33:52 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLReadMaterials.hh,v 1.11 2009/04/24 15:34:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -43,10 +43,10 @@
 #define _G4GDMLREADMATERIALS_INCLUDED_
 
-#include "G4Element.hh"
-#include "G4Isotope.hh"
-#include "G4Material.hh"
-#include "G4NistManager.hh"
+#include "G4Types.hh"
+#include "G4GDMLReadDefine.hh"
 
-#include "G4GDMLReadDefine.hh"
+class G4Element;
+class G4Isotope;
+class G4Material;
 
 class G4GDMLReadMaterials : public G4GDMLReadDefine 
@@ -62,4 +62,7 @@
 
  protected:
+
+   G4GDMLReadMaterials();
+   virtual ~G4GDMLReadMaterials();
 
    G4double AtomRead(const xercesc::DOMElement* const);
Index: trunk/source/persistency/gdml/include/G4GDMLReadParamvol.hh
===================================================================
--- trunk/source/persistency/gdml/include/G4GDMLReadParamvol.hh	(revision 1227)
+++ trunk/source/persistency/gdml/include/G4GDMLReadParamvol.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLReadParamvol.hh,v 1.6 2008/11/20 15:33:52 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLReadParamvol.hh,v 1.8 2009/04/24 15:34:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -42,11 +42,8 @@
 #define _G4GDMLREADPARAMVOL_INCLUDED_
 
-#include "G4LogicalVolume.hh"
-#include "G4PVParameterised.hh"
-#include "G4PVPlacement.hh"
-#include "G4VPhysicalVolume.hh"
+#include "G4GDMLReadSetup.hh"
+#include "G4GDMLParameterisation.hh"
 
-#include "G4GDMLParameterisation.hh"
-#include "G4GDMLReadSetup.hh"
+class G4LogicalVolume;
 
 class G4GDMLReadParamvol : public G4GDMLReadSetup
@@ -60,4 +57,7 @@
 
  protected:
+
+   G4GDMLReadParamvol();
+   virtual ~G4GDMLReadParamvol();
 
    void Box_dimensionsRead(const xercesc::DOMElement* const,
Index: trunk/source/persistency/gdml/include/G4GDMLReadSetup.hh
===================================================================
--- trunk/source/persistency/gdml/include/G4GDMLReadSetup.hh	(revision 1227)
+++ trunk/source/persistency/gdml/include/G4GDMLReadSetup.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLReadSetup.hh,v 1.5 2008/11/20 15:33:52 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLReadSetup.hh,v 1.6 2009/03/24 15:47:33 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -58,4 +58,9 @@
  protected:
 
+   G4GDMLReadSetup();
+   virtual ~G4GDMLReadSetup();
+
+ protected:
+
    std::map<G4String,G4String> setupMap;
 };
Index: trunk/source/persistency/gdml/include/G4GDMLReadSolids.hh
===================================================================
--- trunk/source/persistency/gdml/include/G4GDMLReadSolids.hh	(revision 1227)
+++ trunk/source/persistency/gdml/include/G4GDMLReadSolids.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLReadSolids.hh,v 1.12 2008/11/21 09:32:46 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLReadSolids.hh,v 1.15 2009/04/24 15:34:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -42,39 +42,12 @@
 #define _G4GDMLREADSOLIDS_INCLUDED_
 
-#include "G4Box.hh"
-#include "G4Cons.hh"
-#include "G4Ellipsoid.hh"
-#include "G4EllipticalCone.hh"
-#include "G4EllipticalTube.hh"
+#include "G4Types.hh"
+#include "G4GDMLReadMaterials.hh"
 #include "G4ExtrudedSolid.hh"
-#include "G4Hype.hh"
-#include "G4IntersectionSolid.hh"
-#include "G4Orb.hh"
-#include "G4Para.hh"
-#include "G4Paraboloid.hh"
-#include "G4Polycone.hh"
-#include "G4Polyhedra.hh"
-#include "G4QuadrangularFacet.hh"
-#include "G4ReflectedSolid.hh"
-#include "G4Sphere.hh"
-#include "G4SolidStore.hh"
-#include "G4SubtractionSolid.hh"
-#include "G4TessellatedSolid.hh"
-#include "G4Tet.hh"
-#include "G4Torus.hh"
-#include "G4Transform3D.hh"
-#include "G4Trap.hh"
-#include "G4Trd.hh"
-#include "G4TriangularFacet.hh"
-#include "G4Tubs.hh"
-#include "G4TwistedBox.hh"
-#include "G4TwistedTrap.hh"
-#include "G4TwistedTrd.hh"
-#include "G4TwistedTubs.hh"
-#include "G4UnionSolid.hh"
-#include "G4OpticalSurface.hh"
-#include "G4SurfaceProperty.hh"
 
-#include "G4GDMLReadMaterials.hh"
+class G4VSolid;
+class G4QuadrangularFacet;
+class G4TriangularFacet;
+class G4SurfaceProperty;
 
 class G4GDMLReadSolids : public G4GDMLReadMaterials
@@ -91,4 +64,7 @@
 
  protected:
+
+   G4GDMLReadSolids();
+   virtual ~G4GDMLReadSolids();
 
    void BooleanRead(const xercesc::DOMElement* const,const BooleanOp);
@@ -122,5 +98,5 @@
    G4TwoVector TwoDimVertexRead(const xercesc::DOMElement* const,G4double);
    zplaneType ZplaneRead(const xercesc::DOMElement* const);
-   void OpticalsurfaceRead(const xercesc::DOMElement* const);
+   void OpticalSurfaceRead(const xercesc::DOMElement* const);
 };
 
Index: trunk/source/persistency/gdml/include/G4GDMLReadStructure.hh
===================================================================
--- trunk/source/persistency/gdml/include/G4GDMLReadStructure.hh	(revision 1227)
+++ trunk/source/persistency/gdml/include/G4GDMLReadStructure.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLReadStructure.hh,v 1.24 2009/02/24 17:41:44 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLReadStructure.hh,v 1.28 2009/09/24 15:04:34 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -42,20 +42,12 @@
 #define _G4GDMLREADSTRUCTURE_INCLUDED_
 
-#include "G4AssemblyVolume.hh"
-#include "G4LogicalVolume.hh"
-#include "G4LogicalVolumeStore.hh"
-#include "G4PhysicalVolumeStore.hh"
-#include "G4PVDivision.hh"
-#include "G4PVPlacement.hh"
-#include "G4PVReplica.hh"
-#include "G4SolidStore.hh"
-#include "G4VPhysicalVolume.hh"
-#include "G4ReflectionFactory.hh"
-#include "G4PhysicalVolumeStore.hh"
-#include "G4LogicalSkinSurface.hh"
-#include "G4LogicalBorderSurface.hh"
-#include "G4PVDivisionFactory.hh"
+#include "G4Types.hh"
+#include "geomdefs.hh"
 
 #include "G4GDMLReadParamvol.hh"
+
+class G4AssemblyVolume;
+class G4LogicalVolume;
+class G4VPhysicalVolume;
 
 struct G4GDMLAuxPairType
@@ -67,4 +59,5 @@
 typedef std::vector<G4GDMLAuxPairType> G4GDMLAuxListType;
 typedef std::map<const G4LogicalVolume*,G4GDMLAuxListType> G4GDMLAuxMapType;
+typedef std::map<G4String, G4AssemblyVolume*> G4GDMLAssemblyMapType;
 
 class G4GDMLReadStructure : public G4GDMLReadParamvol
@@ -73,6 +66,10 @@
  public:
 
+   G4GDMLReadStructure();
+   virtual ~G4GDMLReadStructure();
+
    G4VPhysicalVolume* GetPhysvol(const G4String&) const;
    G4LogicalVolume* GetVolume(const G4String&) const;
+   G4AssemblyVolume* GetAssembly(const G4String&) const;
    G4GDMLAuxListType GetVolumeAuxiliaryInformation(const G4LogicalVolume* const);
    G4VPhysicalVolume* GetWorldVolume(const G4String&);
@@ -86,8 +83,9 @@
 
    G4GDMLAuxPairType AuxiliaryRead(const xercesc::DOMElement* const);
-   void BordersurfaceRead(const xercesc::DOMElement* const);
+   void AssemblyRead(const xercesc::DOMElement* const);
    void DivisionvolRead(const xercesc::DOMElement* const);
    G4LogicalVolume* FileRead(const xercesc::DOMElement* const);
-   void PhysvolRead(const xercesc::DOMElement* const);
+   void PhysvolRead(const xercesc::DOMElement* const,
+                    G4AssemblyVolume* assembly=0);
    void ReplicavolRead(const xercesc::DOMElement* const, G4int number);
    void ReplicaRead(const xercesc::DOMElement* const replicaElement,
@@ -95,9 +93,11 @@
    EAxis AxisRead(const xercesc::DOMElement* const axisElement);
    G4double QuantityRead(const xercesc::DOMElement* const readElement);
-   void SkinsurfaceRead(const xercesc::DOMElement* const);
+   void BorderSurfaceRead(const xercesc::DOMElement* const);
+   void SkinSurfaceRead(const xercesc::DOMElement* const);
 
  protected:
 
    G4GDMLAuxMapType auxMap;
+   G4GDMLAssemblyMapType assemblyMap;
    G4LogicalVolume *pMotherLogical;
 
Index: trunk/source/persistency/gdml/include/G4GDMLWrite.hh
===================================================================
--- trunk/source/persistency/gdml/include/G4GDMLWrite.hh	(revision 1227)
+++ trunk/source/persistency/gdml/include/G4GDMLWrite.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLWrite.hh,v 1.37 2008/08/19 15:03:17 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLWrite.hh,v 1.41 2009/04/24 15:34:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -42,6 +42,5 @@
 #define _G4GDMLWRITE_INCLUDED_
 
-#include <sys/stat.h>
-#include <iostream>
+#include <map>
 
 #include <xercesc/dom/DOM.hpp>
@@ -50,56 +49,80 @@
 #include <xercesc/framework/LocalFileFormatTarget.hpp>
 
-#include "G4LogicalVolume.hh"
 #include "G4Transform3D.hh"
-#include "G4PVDivision.hh"
+
+class G4LogicalVolume;
+class G4VPhysicalVolume;
 
 class G4GDMLWrite
 {
-   typedef std::map<const G4LogicalVolume*,G4Transform3D> VolumeMapType;
-   typedef std::map<const G4VPhysicalVolume*,G4String> PhysVolumeMapType;
-   typedef std::map<G4int,G4int> DepthMapType;
+  typedef std::map<const G4LogicalVolume*,G4Transform3D> VolumeMapType;
+  typedef std::map<const G4VPhysicalVolume*,G4String> PhysVolumeMapType;
+  typedef std::map<G4int,G4int> DepthMapType;
 
- public:  // without description
+  public:  // with description
 
-   G4Transform3D Write(const G4String& filename,
-                       const G4LogicalVolume* const topLog,
-                       const G4String& schemaPath,
-                       const G4int depth, G4bool storeReferences=true);
-   void AddModule(const G4VPhysicalVolume* const topVol);
-   void AddModule(const G4int depth);
-   static void SetAddPointerToName(G4bool);
+    G4Transform3D Write(const G4String& filename,
+                        const G4LogicalVolume* const topLog,
+                        const G4String& schemaPath,
+                        const G4int depth, G4bool storeReferences=true);
+      //
+      // Main method for writing GDML files.
 
- protected:
+    void AddModule(const G4VPhysicalVolume* const topVol);
+    void AddModule(const G4int depth);
+      //
+      // Split geometry structure in modules, by volume subtree or level
 
-   G4String SchemaLocation;
+    static void SetAddPointerToName(G4bool);
+      //
+      // Specify if to add or not memory addresses to IDs.
 
-   VolumeMapType& VolumeMap();
+    virtual void DefineWrite(xercesc::DOMElement*)=0;
+    virtual void MaterialsWrite(xercesc::DOMElement*)=0;
+    virtual void SolidsWrite(xercesc::DOMElement*)=0;
+    virtual void StructureWrite(xercesc::DOMElement*)=0;
+    virtual G4Transform3D TraverseVolumeTree(const G4LogicalVolume* const,
+                                             const G4int)=0;
+    virtual void SurfacesWrite()=0;
+    virtual void SetupWrite(xercesc::DOMElement*,
+                            const G4LogicalVolume* const)=0;
+      //
+      // Pure virtual methods implemented in concrete writer plugin's classes
 
-   G4String GenerateName(const G4String&,const void* const);
-   xercesc::DOMAttr* NewAttribute(const G4String&, const G4String&);
-   xercesc::DOMAttr* NewAttribute(const G4String&, const G4double&);
-   xercesc::DOMElement* NewElement(const G4String&);
-   virtual void DefineWrite(xercesc::DOMElement*)=0;
-   virtual void MaterialsWrite(xercesc::DOMElement*)=0;
-   virtual void SolidsWrite(xercesc::DOMElement*)=0;
-   virtual void StructureWrite(xercesc::DOMElement*)=0;
-   virtual G4Transform3D TraverseVolumeTree(const G4LogicalVolume* const,
-                                            const G4int)=0;
-   virtual void SetupWrite(xercesc::DOMElement*,
-                           const G4LogicalVolume* const)=0;
-   G4String Modularize(const G4VPhysicalVolume* const topvol,
-                       const G4int depth);
+    virtual void ExtensionWrite(xercesc::DOMElement*);
+    virtual void AddExtension(xercesc::DOMElement*,
+                              const G4LogicalVolume* const);
+      //
+      // To be implemented in the client code for handling extensions
+      // to the GDML schema, identified with the tag "extension".
+      // The implementation should be placed inside a user-class
+      // inheriting from G4GDMLWriteStructure and being registered
+      // as argument to G4GDMLParser.
 
- private:
+  protected:
 
-   G4bool FileExists(const G4String&) const;
-   PhysVolumeMapType& PvolumeMap();
-   DepthMapType& DepthMap();
+    G4GDMLWrite();
+    virtual ~G4GDMLWrite();
 
- private:
+    VolumeMapType& VolumeMap();
 
-   static G4bool addPointerToName;
-   xercesc::DOMDocument* doc;
-   XMLCh tempStr[100];
+    G4String GenerateName(const G4String&,const void* const);
+    xercesc::DOMAttr* NewAttribute(const G4String&, const G4String&);
+    xercesc::DOMAttr* NewAttribute(const G4String&, const G4double&);
+    xercesc::DOMElement* NewElement(const G4String&);
+    G4String Modularize(const G4VPhysicalVolume* const topvol,
+                        const G4int depth);
+
+    G4bool FileExists(const G4String&) const;
+    PhysVolumeMapType& PvolumeMap();
+    DepthMapType& DepthMap();
+
+  protected:
+
+    G4String SchemaLocation;
+    static G4bool addPointerToName;
+    xercesc::DOMDocument* doc;
+    xercesc::DOMElement* extElement;
+    XMLCh tempStr[100];
 
 };
Index: trunk/source/persistency/gdml/include/G4GDMLWriteDefine.hh
===================================================================
--- trunk/source/persistency/gdml/include/G4GDMLWriteDefine.hh	(revision 1227)
+++ trunk/source/persistency/gdml/include/G4GDMLWriteDefine.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLWriteDefine.hh,v 1.11 2008/07/16 15:46:33 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLWriteDefine.hh,v 1.14 2009/04/24 15:34:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -42,51 +42,55 @@
 #define _G4GDMLWRITEDEFINE_INCLUDED_
 
+#include "G4Types.hh"
+#include "G4ThreeVector.hh"
+#include "G4RotationMatrix.hh"
+
 #include "G4GDMLWrite.hh"
-#include <sstream>
 
 class G4GDMLWriteDefine : public G4GDMLWrite
 {
 
- protected:
+  public:
 
-   G4ThreeVector GetAngles(const G4RotationMatrix&);
-   void ScaleWrite(xercesc::DOMElement* element, const G4String& name,
-                    const G4ThreeVector& scl)
-     { Scale_vectorWrite(element,"scale",name,scl); }
-   void RotationWrite(xercesc::DOMElement* element, const G4String& name,
-                    const G4ThreeVector& rot)
-     { Rotation_vectorWrite(element,"rotation",name,rot); }
-   void PositionWrite(xercesc::DOMElement* element, const G4String& name,
-                    const G4ThreeVector& pos)
-     { Position_vectorWrite(element,"position",name,pos); }
-   void FirstrotationWrite(xercesc::DOMElement* element, const G4String& name,
-                    const G4ThreeVector& rot)
-     { Rotation_vectorWrite(element,"firstrotation",name,rot); }
-   void FirstpositionWrite(xercesc::DOMElement* element, const G4String& name,
-                    const G4ThreeVector& pos)
-     { Position_vectorWrite(element,"firstposition",name,pos); }
-   void AddPosition(const G4String& name,
-                    const G4ThreeVector& pos)
-     { Position_vectorWrite(defineElement,"position",name,pos); }
+    G4ThreeVector GetAngles(const G4RotationMatrix&);
+    void ScaleWrite(xercesc::DOMElement* element,
+                    const G4String& name, const G4ThreeVector& scl)
+         { Scale_vectorWrite(element,"scale",name,scl); }
+    void RotationWrite(xercesc::DOMElement* element,
+                    const G4String& name, const G4ThreeVector& rot)
+         { Rotation_vectorWrite(element,"rotation",name,rot); }
+    void PositionWrite(xercesc::DOMElement* element,
+                    const G4String& name, const G4ThreeVector& pos)
+         { Position_vectorWrite(element,"position",name,pos); }
+    void FirstrotationWrite(xercesc::DOMElement* element,
+                    const G4String& name, const G4ThreeVector& rot)
+         { Rotation_vectorWrite(element,"firstrotation",name,rot); }
+    void FirstpositionWrite(xercesc::DOMElement* element,
+                    const G4String& name, const G4ThreeVector& pos)
+         { Position_vectorWrite(element,"firstposition",name,pos); }
+    void AddPosition(const G4String& name, const G4ThreeVector& pos)
+         { Position_vectorWrite(defineElement,"position",name,pos); }
 
- protected:
+    virtual void DefineWrite(xercesc::DOMElement*);
 
-   static const G4double kRelativePrecision;
-   static const G4double kAngularPrecision;
-   static const G4double kLinearPrecision;
+  protected:
+
+    G4GDMLWriteDefine();
+    virtual ~G4GDMLWriteDefine();
+
+    void Scale_vectorWrite(xercesc::DOMElement*, const G4String&,
+                              const G4String&, const G4ThreeVector&);
+    void Rotation_vectorWrite(xercesc::DOMElement*, const G4String&,
+                              const G4String&, const G4ThreeVector&);
+    void Position_vectorWrite(xercesc::DOMElement*, const G4String&,
+                              const G4String&, const G4ThreeVector&);
+
+  protected:
+
+    static const G4double kRelativePrecision;
+    static const G4double kAngularPrecision;
+    static const G4double kLinearPrecision;
   
- private:
-
-   void Scale_vectorWrite(xercesc::DOMElement*, const G4String&,
-                             const G4String&, const G4ThreeVector&);
-   void Rotation_vectorWrite(xercesc::DOMElement*, const G4String&,
-                             const G4String&, const G4ThreeVector&);
-   void Position_vectorWrite(xercesc::DOMElement*, const G4String&,
-                             const G4String&, const G4ThreeVector&);
-   void DefineWrite(xercesc::DOMElement*);
-
- private:
-
-   xercesc::DOMElement* defineElement;
+    xercesc::DOMElement* defineElement;
 
 };
Index: trunk/source/persistency/gdml/include/G4GDMLWriteMaterials.hh
===================================================================
--- trunk/source/persistency/gdml/include/G4GDMLWriteMaterials.hh	(revision 1227)
+++ trunk/source/persistency/gdml/include/G4GDMLWriteMaterials.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLWriteMaterials.hh,v 1.12 2008/07/16 15:46:33 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLWriteMaterials.hh,v 1.17 2009/04/27 07:22:36 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -42,14 +42,18 @@
 #define _G4GDMLWRITEMATERIALS_INCLUDED_
 
-#include "G4Element.hh"
-#include "G4Isotope.hh"
-#include "G4Material.hh"
+#include "G4Types.hh"
+#include <vector>
 
 #include "G4GDMLWriteDefine.hh"
+
+class G4Isotope;
+class G4Element;
+class G4Material;
+class G4MaterialPropertyVector;
 
 class G4GDMLWriteMaterials : public G4GDMLWriteDefine
 {
 
- protected:
+ public:
 
    void AddIsotope(const G4Isotope* const);
@@ -57,5 +61,10 @@
    void AddMaterial(const G4Material* const);
 
- private:
+   virtual void MaterialsWrite(xercesc::DOMElement*);
+
+ protected:
+
+   G4GDMLWriteMaterials();
+   virtual ~G4GDMLWriteMaterials();
 
    void AtomWrite(xercesc::DOMElement*,const G4double&);
@@ -66,7 +75,8 @@
    void ElementWrite(const G4Element* const);
    void MaterialWrite(const G4Material* const);
-   void MaterialsWrite(xercesc::DOMElement*);
-
- private:
+   void PropertyWrite(xercesc::DOMElement*, const G4Material* const);
+   void PropertyVectorWrite(const G4String&,
+                            const G4MaterialPropertyVector* const);
+ protected:
 
    std::vector<const G4Isotope*> isotopeList;
